
import ecap, msgq, edsm;
import std.stdio;

final class MessageDispatcher {

    EventQueue eq;
    MessageQueue mq;

    this() {
        eq = EventQueue.getInstance();
        mq = MessageQueue.getInstance();
    }

    void loop() {
        do {
            Message msg;
            while (mq.getMsg(msg)) {
                StageMachine sm = msg.dst;
                sm.reactTo(msg);
            }
        } while (eq.wait());
    }
}
